/***************************************************************************
                          dialog.cpp  -  description
                             -------------------
    begin                : Sat Oct 30 1999
    copyright            : (C) 1999 by Peter van Eerten
    email                : emphroon@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>				//Qt libraries
#include <qmessagebox.h>
#include <qfont.h>
#include <qpixmap.h>

#include <string.h>
#include <stdlib.h> 					//needed for linux system calls
#include <iostream.h>

#include "dialog.h"
#include "frontend.h"

interview::interview (QWidget *parent, const char *name)
	: QDialog (parent, name, TRUE)
{
command = new char [60];
homedir = new char [60];				//homedirectory not longer than 60 chars
freq1 = new char [5]; freq2 = new char [5];
freq3 = new char [5]; freq4 = new char [5];
freq5 = new char [5]; freq6 = new char [5];
freq7 = new char [5]; freq8 = new char [5];

ftemp = new char [5];
devicename = new char[20];
last = new char [2];

homedir = getenv ("HOME");
setFont (QFont("Helvetica", 16));
setCaption ("Options for Qradio");

buttons = new QButtonGroup (this, "Buttongroup");
buttons -> setGeometry (10, 10, 230, 180);
rb1 = new QRadioButton (buttons);
rb1 -> setGeometry (10, 5, 65, 20);
rb1 -> setText ("Radio 1:");
connect (rb1, SIGNAL (clicked()), SLOT(setfreq1()));
rb2 = new QRadioButton (buttons);
rb2 -> setGeometry (10, 25, 65, 20);
rb2 -> setText ("Radio 2:");
connect (rb2, SIGNAL (clicked()), SLOT(setfreq2()));
rb3 = new QRadioButton (buttons);
rb3 -> setGeometry (10, 45, 65, 20);
rb3 -> setText ("Radio 3:");
connect (rb3, SIGNAL (clicked()), SLOT(setfreq3()));
rb4 = new QRadioButton (buttons);
rb4 -> setGeometry (10, 65, 65, 20);
rb4 -> setText ("Radio 4:");
connect (rb4, SIGNAL (clicked()), SLOT(setfreq4()));
rb5 = new QRadioButton (buttons);
rb5 -> setGeometry (10, 85, 65, 20);
rb5 -> setText ("Radio 5:");
connect (rb5, SIGNAL (clicked()), SLOT(setfreq5()));
rb6 = new QRadioButton (buttons);
rb6 -> setGeometry (10, 105, 65, 20);
rb6 -> setText ("Radio 6:");
connect (rb6, SIGNAL (clicked()), SLOT(setfreq6()));
rb7 = new QRadioButton (buttons);
rb7 -> setGeometry (10, 125, 65, 20);
rb7 -> setText ("Radio 7:");
connect (rb7, SIGNAL (clicked()), SLOT(setfreq7()));
rb8 = new QRadioButton (buttons);
rb8 -> setGeometry (10, 145, 65, 20);
rb8 -> setText ("Radio 8:");
connect (rb8, SIGNAL (clicked()), SLOT(setfreq8()));

lfreq1 = new QLabel (buttons);
lfreq1 -> setGeometry (90, 5, 30, 20);
lfreq2 = new QLabel (buttons);
lfreq2 -> setGeometry (90, 25, 30, 20);
lfreq3 = new QLabel (buttons);
lfreq3 -> setGeometry (90, 45, 30, 20);
lfreq4 = new QLabel (buttons);
lfreq4 -> setGeometry (90, 65, 30, 20);
lfreq5 = new QLabel (buttons);
lfreq5 -> setGeometry (90, 85, 30, 20);
lfreq6 = new QLabel (buttons);
lfreq6 -> setGeometry (90, 105, 30, 20);
lfreq7 = new QLabel (buttons);
lfreq7 -> setGeometry (90, 125, 30, 20);
lfreq8 = new QLabel (buttons);
lfreq8 -> setGeometry (90, 145, 30, 20);

frdownlarge = new QPushButton ("-1.0", buttons);
frdownlarge -> setGeometry (150, 10, 30, 30);
frdownlarge -> setPalette (QPalette (QColor (100, 100, 100)));
connect (frdownlarge, SIGNAL (clicked()), SLOT (decreaselarge()));
fruplarge = new QPushButton ("+1.0", buttons);
fruplarge -> setGeometry (190, 10, 30, 30);
fruplarge -> setPalette (QPalette (QColor (100, 100, 100)));
connect (fruplarge, SIGNAL (clicked()), SLOT (increaselarge()));
frdown = new QPushButton ("-0.1", buttons);
frdown -> setGeometry (150, 50, 30, 30);
frdown -> setPalette (QPalette (QColor (80, 80, 80)));
connect (frdown, SIGNAL (clicked()), SLOT (decreasesmall()));
frup = new QPushButton ("+0.1", buttons);
frup -> setGeometry (190, 50, 30, 30);
frup -> setPalette (QPalette (QColor (80, 80, 80)));
connect (frup, SIGNAL (clicked()), SLOT (increasesmall()));

exit = new QPushButton ("Exit", this);
exit -> setGeometry (160, 145, 70, 30);
connect (exit, SIGNAL (clicked()), SLOT(exitdialog()));

if (homedir != NULL)					//check file in home directory
{
strcpy (temp, homedir);					//exists? open it
strcat (temp, "/.qradiorc");
defaults = fopen (temp, "r");
}
else defaults = fopen (".qradiorc", "r");		//otherwise, just open file in current dir

if (defaults == NULL)					//is there no file at all?
{
freq1 = "87.5"; freq2 = "87.5";
freq3 = "87.5"; freq4 = "87.5";
freq5 = "87.5"; freq6 = "87.5";
freq7 = "87.5"; freq8 = "87.5";
}
else
{
fscanf (defaults, "%s", freq1);				//read frequency's
fscanf (defaults, "%s", freq2);
fscanf (defaults, "%s", freq3);
fscanf (defaults, "%s", freq4);
fscanf (defaults, "%s", freq5);				
fscanf (defaults, "%s", freq6);
fscanf (defaults, "%s", freq7);
fscanf (defaults, "%s", freq8);
fscanf (defaults, "%s", last);
fclose (defaults);
}
lfreq1 -> setText (freq1);				//put frequencynumbers in labels
lfreq2 -> setText (freq2);
lfreq3 -> setText (freq3);
lfreq4 -> setText (freq4);
lfreq5 -> setText (freq5);				
lfreq6 -> setText (freq6);
lfreq7 -> setText (freq7);
lfreq8 -> setText (freq8);
}

void interview::increaselarge()
{
int frequency;
if (rb1 -> isChecked()) ftemp = freq1;			//determine which frequency has to be changed
else if (rb2 -> isChecked()) ftemp = freq2;
else if (rb3 -> isChecked()) ftemp = freq3;
else if (rb4 -> isChecked()) ftemp = freq4;
else if (rb5 -> isChecked()) ftemp = freq5;
else if (rb6 -> isChecked()) ftemp = freq6;
else if (rb7 -> isChecked()) ftemp = freq7;
else if (rb8 -> isChecked()) ftemp = freq8;
else return;  						//nothing checked? Just return the call.

strcpy (temp, ftemp);					//copy to string to determine length, then convert to integer
if ((strlen (temp) - 1) == 3)
	frequency = (int(ftemp[0])-48)*100 + (int(ftemp[1])-48)*10 + int(ftemp[3])-48;
else
{
if ((strlen (temp) - 1) == 4)
	frequency = (int(ftemp[0])-48)*1000 + (int(ftemp[1])-48)*100 + (int(ftemp[2])-48)*10 + int(ftemp[4])-48;
else frequency = 875;
}
frequency += 10;
if (frequency > 1080) frequency = 875;					//frequency cannot become higher than 108.0
ftemp[0] = frequency/1000+48; frequency -= (int(ftemp[0])-48)*1000;	//convert back to array of chars
ftemp[1] = frequency/100+48; frequency -= (int(ftemp[1])-48)*100;
ftemp[2] = frequency/10+48; frequency -= (int(ftemp[2])-48)*10;
ftemp[3] = '.';
ftemp[4] = frequency+48;
ftemp[5] = '\0';

if (ftemp[0] == 48)
{
ftemp[0] = ftemp[1]; ftemp[1] = ftemp[2];                               //delete any '0' before frequency number
ftemp[2] = ftemp[3]; ftemp[3] = ftemp[4]; ftemp[4] = ftemp[5];
}
strcpy (temp, "fm ");							//emit new frequency to BASH
strcat (temp, ftemp);
strcat (temp, " 65535");
command = temp;								//convert to char pointer
system (command);
if (rb1 -> isChecked()){freq1 = ftemp; lfreq1 -> setText (ftemp);}		//put changed frequency back to original variable
if (rb2 -> isChecked()){freq2 = ftemp; lfreq2 -> setText (ftemp);}		//and change value in label
if (rb3 -> isChecked()){freq3 = ftemp; lfreq3 -> setText (ftemp);}
if (rb4 -> isChecked()){freq4 = ftemp; lfreq4 -> setText (ftemp);}
if (rb5 -> isChecked()){freq5 = ftemp; lfreq5 -> setText (ftemp);}
if (rb6 -> isChecked()){freq6 = ftemp; lfreq6 -> setText (ftemp);}
if (rb7 -> isChecked()){freq7 = ftemp; lfreq7 -> setText (ftemp);}
if (rb8 -> isChecked()){freq8 = ftemp; lfreq8 -> setText (ftemp);}
}

void interview::decreaselarge()
{
int frequency;
if (rb1 -> isChecked()) ftemp = freq1;			//determine which frequency has to be changed
else if (rb2 -> isChecked()) ftemp = freq2;
else if (rb3 -> isChecked()) ftemp = freq3;
else if (rb4 -> isChecked()) ftemp = freq4;
else if (rb5 -> isChecked()) ftemp = freq5;
else if (rb6 -> isChecked()) ftemp = freq6;
else if (rb7 -> isChecked()) ftemp = freq7;
else if (rb8 -> isChecked()) ftemp = freq8;
else return;  						//nothing checked? Just return the call.

strcpy (temp, ftemp);					//copy to string to determine length, then convert to integer
if ((strlen (temp) - 1) == 3)
	frequency = (int(ftemp[0])-48)*100 + (int(ftemp[1])-48)*10 + int(ftemp[3])-48;
else
{
if ((strlen (temp) - 1) == 4)
	frequency = (int(ftemp[0])-48)*1000 + (int(ftemp[1])-48)*100 + (int(ftemp[2])-48)*10 + int(ftemp[4])-48;
else frequency = 875;
}
frequency -= 10;
if (frequency < 875) frequency = 1080;					//frequency cannot become lower than 87.5
ftemp[0] = frequency/1000+48; frequency -= (int(ftemp[0])-48)*1000;	//convert back to array of chars
ftemp[1] = frequency/100+48; frequency -= (int(ftemp[1])-48)*100;
ftemp[2] = frequency/10+48; frequency -= (int(ftemp[2])-48)*10;
ftemp[3] = '.';
ftemp[4] = frequency+48;
ftemp[5] = '\0';
if (ftemp[0] == 48)
{
ftemp[0] = ftemp[1]; ftemp[1] = ftemp[2]; 				//delete any '0' before frequency number
ftemp[2] = ftemp[3]; ftemp[3] = ftemp[4]; ftemp[4] = ftemp[5];
}
strcpy (temp, "fm ");
strcat (temp, ftemp);
strcat (temp, " 65535");
command = temp;								//convert to char pointer
system (command);
if (rb1 -> isChecked()){freq1 = ftemp; lfreq1 -> setText (ftemp);}		//put changed frequency back to original variable
if (rb2 -> isChecked()){freq2 = ftemp; lfreq2 -> setText (ftemp);}		//and change value in label
if (rb3 -> isChecked()){freq3 = ftemp; lfreq3 -> setText (ftemp);}
if (rb4 -> isChecked()){freq4 = ftemp; lfreq4 -> setText (ftemp);}
if (rb5 -> isChecked()){freq5 = ftemp; lfreq5 -> setText (ftemp);}
if (rb6 -> isChecked()){freq6 = ftemp; lfreq6 -> setText (ftemp);}
if (rb7 -> isChecked()){freq7 = ftemp; lfreq7 -> setText (ftemp);}
if (rb8 -> isChecked()){freq8 = ftemp; lfreq8 -> setText (ftemp);}
}

void interview::increasesmall()
{
int frequency;
if (rb1 -> isChecked()) ftemp = freq1;			//determine which frequency has to be changed
else if (rb2 -> isChecked()) ftemp = freq2;
else if (rb3 -> isChecked()) ftemp = freq3;
else if (rb4 -> isChecked()) ftemp = freq4;
else if (rb5 -> isChecked()) ftemp = freq5;
else if (rb6 -> isChecked()) ftemp = freq6;
else if (rb7 -> isChecked()) ftemp = freq7;
else if (rb8 -> isChecked()) ftemp = freq8;
else return;  						//nothing checked? Just return the call.

strcpy (temp, ftemp);					//copy to string to determine length, then convert to integer
if ((strlen (temp) - 1) == 3)
	frequency = (int(ftemp[0])-48)*100 + (int(ftemp[1])-48)*10 + int(ftemp[3])-48;
else
{
if ((strlen (temp) - 1) == 4)
	frequency = (int(ftemp[0])-48)*1000 + (int(ftemp[1])-48)*100 + (int(ftemp[2])-48)*10 + int(ftemp[4])-48;
else frequency = 875;
}
frequency += 1;
if (frequency > 1080) frequency = 875;					//frequency cannot become higher than 108.0
ftemp[0] = frequency/1000+48; frequency -= (int(ftemp[0])-48)*1000; 	//convert back to array of chars
ftemp[1] = frequency/100+48; frequency -= (int(ftemp[1])-48)*100;
ftemp[2] = frequency/10+48; frequency -= (int(ftemp[2])-48)*10;
ftemp[3] = '.';
ftemp[4] = frequency+48;
ftemp[5] = '\0';
if (ftemp[0] == 48)
{
ftemp[0] = ftemp[1]; ftemp[1] = ftemp[2];				//delete any '0' before frequency number
ftemp[2] = ftemp[3]; ftemp[3] = ftemp[4]; ftemp[4] = ftemp[5];
}
strcpy (temp, "fm ");							//emit new frequency to BASH
strcat (temp, ftemp);
strcat (temp, " 65535");
command = temp;								//convert to char pointer
system (command);
if (rb1 -> isChecked()){freq1 = ftemp; lfreq1 -> setText (ftemp);}		//put changed frequency back to original variable
if (rb2 -> isChecked()){freq2 = ftemp; lfreq2 -> setText (ftemp);}		//and change value in label
if (rb3 -> isChecked()){freq3 = ftemp; lfreq3 -> setText (ftemp);}
if (rb4 -> isChecked()){freq4 = ftemp; lfreq4 -> setText (ftemp);}
if (rb5 -> isChecked()){freq5 = ftemp; lfreq5 -> setText (ftemp);}
if (rb6 -> isChecked()){freq6 = ftemp; lfreq6 -> setText (ftemp);}
if (rb7 -> isChecked()){freq7 = ftemp; lfreq7 -> setText (ftemp);}
if (rb8 -> isChecked()){freq8 = ftemp; lfreq8 -> setText (ftemp);}
}

void interview::decreasesmall()
{
int frequency;
if (rb1 -> isChecked()) ftemp = freq1;			//determine which frequency has to be changed
else if (rb2 -> isChecked()) ftemp = freq2;
else if (rb3 -> isChecked()) ftemp = freq3;
else if (rb4 -> isChecked()) ftemp = freq4;
else if (rb5 -> isChecked()) ftemp = freq5;
else if (rb6 -> isChecked()) ftemp = freq6;
else if (rb7 -> isChecked()) ftemp = freq7;
else if (rb8 -> isChecked()) ftemp = freq8;
else return;  						//nothing checked? Just return the call.

strcpy (temp, ftemp);					//copy to string to determine length, then convert to integer
if ((strlen (temp) - 1) == 3)
	frequency = (int(ftemp[0])-48)*100 + (int(ftemp[1])-48)*10 + int(ftemp[3])-48;
else
{
if ((strlen (temp) - 1) == 4)
	frequency = (int(ftemp[0])-48)*1000 + (int(ftemp[1])-48)*100 + (int(ftemp[2])-48)*10 + int(ftemp[4])-48;
else frequency = 875;
}
frequency -= 1;
if (frequency < 875) frequency = 1080;					//frequency cannot become lower than 87.5
ftemp[0] = frequency/1000+48; frequency -= (int(ftemp[0])-48)*1000;	//convert back to array of chars
ftemp[1] = frequency/100+48; frequency -= (int(ftemp[1])-48)*100;
ftemp[2] = frequency/10+48; frequency -= (int(ftemp[2])-48)*10;
ftemp[3] = '.';
ftemp[4] = frequency+48;
ftemp[5] = '\0';
if (ftemp[0] == 48)
{
ftemp[0] = ftemp[1]; ftemp[1] = ftemp[2];				//delete any '0' before frequency number
ftemp[2] = ftemp[3]; ftemp[3] = ftemp[4]; ftemp[4] = ftemp[5];
}
strcpy (temp, "fm ");
strcat (temp, ftemp);
strcat (temp, " 65535");
command = temp;								//convert to char pointer
system (command);
if (rb1 -> isChecked()){freq1 = ftemp; lfreq1 -> setText (ftemp);}		//put changed frequency back to original variable
if (rb2 -> isChecked()){freq2 = ftemp; lfreq2 -> setText (ftemp);}		//and change value in label
if (rb3 -> isChecked()){freq3 = ftemp; lfreq3 -> setText (ftemp);}
if (rb4 -> isChecked()){freq4 = ftemp; lfreq4 -> setText (ftemp);}
if (rb5 -> isChecked()){freq5 = ftemp; lfreq5 -> setText (ftemp);}
if (rb6 -> isChecked()){freq6 = ftemp; lfreq6 -> setText (ftemp);}
if (rb7 -> isChecked()){freq7 = ftemp; lfreq7 -> setText (ftemp);}
if (rb8 -> isChecked()){freq8 = ftemp; lfreq8 -> setText (ftemp);}
}

void interview::setfreq1()
{
strcpy (temp, "fm ");
strcat (temp, freq1);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq2()
{
strcpy (temp, "fm ");
strcat (temp, freq2);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq3()
{
strcpy (temp, "fm ");
strcat (temp, freq3);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq4()
{
strcpy (temp, "fm ");
strcat (temp, freq4);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq5()
{
strcpy (temp, "fm ");
strcat (temp, freq5);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq6()
{
strcpy (temp, "fm ");
strcat (temp, freq6);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq7()
{
strcpy (temp, "fm ");
strcat (temp, freq7);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::setfreq8()
{
strcpy (temp, "fm ");
strcat (temp, freq8);
strcat (temp, " 65535");
command = temp;						//convert to char pointer
system (command);
}

void interview::select (int button)
{
switch (button)
{
case 1: rb1 -> setChecked (TRUE); break;
case 2: rb2 -> setChecked (TRUE); break;
case 3: rb3 -> setChecked (TRUE); break;
case 4: rb4 -> setChecked (TRUE); break;
case 5: rb5 -> setChecked (TRUE); break;
case 6: rb6 -> setChecked (TRUE); break;
case 7: rb7 -> setChecked (TRUE); break;
case 8: rb8 -> setChecked (TRUE); break;
}
}

void interview::exitdialog()
{
int result;
result = 0;

if (homedir != NULL)
{
strcpy (temp, homedir);					//goto homedirectory if $HOME is existing
strcat (temp, "/.qradiorc");
defaults = fopen (temp, "w");
}
else defaults = fopen (".qradiorc", "w");		//otherwise, use current directory

fprintf (defaults, " "); fprintf (defaults, freq1);	//save frequency's to .qtradiorc
fprintf (defaults, " "); fprintf (defaults, freq2);
fprintf (defaults, " "); fprintf (defaults, freq3);
fprintf (defaults, " "); fprintf (defaults, freq4);
fprintf (defaults, " "); fprintf (defaults, freq5);	
fprintf (defaults, " "); fprintf (defaults, freq6);
fprintf (defaults, " "); fprintf (defaults, freq7);
fprintf (defaults, " "); fprintf (defaults, freq8);
fprintf (defaults, " "); fprintf (defaults, last);
fclose (defaults);

if (rb1->isChecked()) {frontend_ptr->radio1->setOn(TRUE); frontend_ptr->setfreq1();}
if (rb2->isChecked()) {frontend_ptr->radio2->setOn(TRUE); frontend_ptr->setfreq2();}
if (rb3->isChecked()) {frontend_ptr->radio3->setOn(TRUE); frontend_ptr->setfreq3();}
if (rb4->isChecked()) {frontend_ptr->radio4->setOn(TRUE); frontend_ptr->setfreq4();}
if (rb5->isChecked()) {frontend_ptr->radio5->setOn(TRUE); frontend_ptr->setfreq5();}
if (rb6->isChecked()) {frontend_ptr->radio6->setOn(TRUE); frontend_ptr->setfreq6();}
if (rb7->isChecked()) {frontend_ptr->radio7->setOn(TRUE); frontend_ptr->setfreq7();}
if (rb8->isChecked()) {frontend_ptr->radio8->setOn(TRUE); frontend_ptr->setfreq8();}

QDialog::done(result);
}