/***************************************************************************
                          dialog.h  -  description
                             -------------------
    begin                : Sat Oct 30 1999
    copyright            : (C) 1999 by Peter van Eerten
    email                : emphroon@yahoo.com
 ***************************************************************************

 dialog.h: a dialog for the Qt radio front end to the Aztech/Packard Bell card

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIALOG_H
#define DIALOG_H

#include <qdialog.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include "frontend.h"

#include <stdio.h>			//needed for FILE declaration

class interview : public QDialog
{
Q_OBJECT
public:
	interview (QWidget *parent=0, const char *name=0);
	void select (int button);
	radiofrontend *frontend_ptr;	//let class have a pointer to actual frontend

private slots:
	void exitdialog ();
	void increaselarge ();
	void decreaselarge ();
	void increasesmall ();
	void decreasesmall ();
	void setfreq1 ();
	void setfreq2 ();
	void setfreq3 ();
	void setfreq4 ();
    void setfreq5 ();
	void setfreq6 ();
	void setfreq7 ();
	void setfreq8 ();

private:
	QPushButton *exit;		//declare components here for resize
	QPushButton *frup;
	QPushButton *frdown;
	QPushButton *fruplarge;
	QPushButton *frdownlarge;

	QLabel *devicetext;
	QButtonGroup *buttons;
	QRadioButton *rb1;
	QRadioButton *rb2;
	QRadioButton *rb3;
	QRadioButton *rb4;
	QRadioButton *rb5;
	QRadioButton *rb6;
	QRadioButton *rb7;
	QRadioButton *rb8;
	QLabel *lfreq1;
	QLabel *lfreq2;
	QLabel *lfreq3;
	QLabel *lfreq4;
	QLabel *lfreq5;
	QLabel *lfreq6;
	QLabel *lfreq7;
	QLabel *lfreq8;

	FILE *defaults;	  		//filename used for reading the settings file .qtradiorc
	char *homedir;			//keeps $HOME environment variable
	char *devicename;		//keeps name of the device file
	char *command;			//used to emit commands to BASH
	char *freq1;			//used to store frequency's in  87.5-108.0
	char *freq2;
	char *freq3;
	char *freq4;
	char *freq5;
	char *freq6;
	char *freq7;
	char *freq8;
	char *last;				//store last frequency in
	char *ftemp;			//temporary storage of frequency's

 	char temp [80];			//used for string trick purposes
};

#endif
