/***************************************************************************
                          frontend.h  -  description
                             -------------------
    begin                : Sat Oct 30 1999
    copyright            : (C) 1999 by Peter van Eerten
    email                : emphroon@yahoo.com
 ***************************************************************************

	frontend.h: a Qt radio front end to the Aztech/Packard Bell card

***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RADIO_H
#define RADIO_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qbuttongroup.h>

#include <stdio.h> 										//needed for FILE declaration

class radiofrontend : public QWidget
{
Q_OBJECT
public:
	radiofrontend (QWidget *parent=0, const char *name=0);
	void select ();

private slots:
	void volset ();
	void aboutmsg ();
	void opendialog ();
	void quitfrontend ();

public slots:
	void setfreq1 ();
	void setfreq2 ();
	void setfreq3 ();
	void setfreq4 ();
	void setfreq5 ();
	void setfreq6 ();
	void setfreq7 ();
	void setfreq8 ();	

private:
	QPushButton *quit;					//declare components here for resize
	QButtonGroup *radiobuttons;
	QPushButton *volume;
	QPushButton *about;
	QPushButton *options;
	QLCDNumber *band;
	
public:
	QPushButton *radio1;
	QPushButton *radio2;
	QPushButton *radio3;
	QPushButton *radio4;
	QPushButton *radio5;
	QPushButton *radio6;
	QPushButton *radio7;
	QPushButton *radio8;
	
	FILE *defaults;	  				//filename used for reading the settings file .qtradiorc
	char *command;					//used for emitting BASH commands to the radio device
	char *homedir;					//used to read environment variable $HOME
	char *freq1;					//used to store frequency's in  87.5-108.0
	char *freq2;
	char *freq3;
	char *freq4;
	char *freq5;
	char *freq6;
	char *freq7;
	char *freq8;
	char *last;						//keeps track of last frequency

	bool mutetoggle; 				//keeps track of mute on (true) mute off (false)
	bool stereotoggle;				//keeps track of stereo on (true) stereo off (false)

	char temp [80];					//temp variable for string trick purposes
};

#endif
